//QC is a structure containing the charge colour infomation for a particular particle

#ifndef __QC_h__
#define __QC_h__


typedef struct{
    int *x; //the components
} QC;

void QC_reset(QC *q); //set all values zero
QC *QC_new();         //create a new vector
void QC_print(QC *q); //print the entire vector
void QC_destroy(QC *q); //destroy the memory associated with the vector
int QC_get(QC *q, int i); //return value at pos i of q
void QC_put(QC *q, int i, int value); //put q[i]=value
void QC_add(QC *q1, QC *q2, QC *q3); //add contents of q1, q2 and assign to q3
void QC_sub(QC *q1, QC *q2, QC *q3); //set q3= q1-q2 subtracting component wise
void QC_set_equal(QC *q1, QC *q2);  //set q1=q2
void QC_fprint(QC *q1, FILE * pFile7); //print to file
void QC_put_colour(QC *q, int i, int j, int k); //put i,j,k into q[1],[2],[3]

//compare elements x[*i] and x[*j] of q
//if x[i]<x[j] switch the values of (*i) and (*j)
void QC_compare_swap(QC *q,int *i,int *j);

//increase q[i] by x
void QC_eadd(QC *q,int i, int x);

//return 1 if q has at least one non-zero element
int QC_nonzero(QC *q);

void QC_resetc(QC *q); //reset the elements q[i] from i=1 to t=3

#endif /* __QC_h__ */
