#ifndef __Spect_h__
#define __Spect_h__

typedef struct{
    //memory used to hold spectrum information in all cases
    double ***spectrum;
    double *Epow_s;

    //parameter for lisa two body model
    double rho;

    //extra memory for if blackhole is rotating
    double ****A_ro,****B_ro,****C_ro,****D_ro,****location,****eigen_ro,***eigen_location;
    double *aa_r, **angl_spectrum;
    double ****spectrum_r;
    double **Epow_r;

} Spect;

Spect *Spect_new();
void Spect_readparam();  //set up parameters of the spectrum

//functions called by Spect_readparam if needed
void Spect_spectrum_norotating(); //set spectrum non-rotating
void Spect_spectrum_norotating_tension(); //set spectrum non-rotating with tension
void Spect_read_parameter_rotating(); //begin setting spectrum rotating
void Spect_set_parameter_lisa(); //lisa model

//if blackhole is rotating spectrum must be recalculated after each hawking emmission, this function does this
void Spect_calculate_spectrum_rotating();


#endif /* __Spect_h__ */
